!BM---------------------------------------
module forcefieldc4

contains
  !BS-------------------------------------------
  subroutine execC4(x,syst)
  use stringlengths;use shell;use carint
  use types;use assign_objects;use alloc_objects
  implicit none
  type(system_type), intent(in) :: syst
  integer :: N, counter
  character*2 :: atom_types(syst%Npart)
  double precision, intent(in) :: x(syst%Npart,3)
  logical :: wait, wait2
  !character(LEN=LSTR)::command
  
  N = syst%Npart
  atom_types=syst%ATOM_TYPES 

  !INQUIRE(file='CFOUR.OUT', EXIST=wait)
  !if(wait) then
  !  call do_shell('rm CFOUR.OUT')
  !end if
  
  !INQUIRE(file='GRD', EXIST=wait)
  !if(wait) then
  !  call do_shell('rm GRD.OUT')
  !end if

  ! Creating new geometry file, internal coordinates
  call cartoint(atom_types,x,N,'GEOMETRY')
  
  ! Combining new geometry with HEAD and TAIL to make valid input
  call do_shell('cat input.C4_HEAD GEOMETRY input.C4_TAIL > water.zmat')
  
  call do_shell('./runscript.sh')

  counter=0
  do
    INQUIRE(file='CFOUR.OUT', EXIST=wait) 
    INQUIRE(file='GRD', EXIST=wait2) 
    if(wait .and. wait2) go to 30
    !if(wait2) go to 30
    call sleep(1) 
    counter=counter+1
    if(counter.gt.1000)then
      write(*,*)'Waited 1000 seconds..'
      write(*,*)'CFour crashed..?'
      stop
    end if
  end do
30 continue
  write(*,*)'Waited ',counter,'seconds for CFOUR-files'
  call do_shell('rm GEOMETRY')

  end subroutine execC4
  !ES-------------------------------------------
  
  !BF-------------------------------------------
  function forceC4(x,syst,c4param)
  use shell; use stringlengths
  use types;use assign_objects;use alloc_objects
  implicit none
  type(system_type),     intent(in)::syst
  type(potc4_type),    intent(in)::c4param
  double precision, intent(in)::x(syst%Npart,syst%dim)
  character*2 :: atom_types(syst%Npart)
  double precision::forcec4(syst%Npart,syst%dim),meh
  character(LEN=LSTR) :: command
  logical :: filecheck
  integer :: N,i
  
  N = syst%Npart

  INQUIRE(file='GRD', EXIST=filecheck)
  if (.not. filecheck) then
    call execC4(x,syst)
  end if

  write(command, '(A8,I2,A9)'), "tail -n ",N," GRD > ff"
  call do_shell(command)
  
  open(unit=66, file='ff', status='old', action='read')
  do i = 1,N
    read(66,*), meh, forceC4(i,:)
  end do
  close(unit=66)
  
  call do_shell('rm -rf ff GRD')
  
  end function forceC4
  !EF------------------------------------------


  !BF------------------------------------------
  function EpotC4(x,syst,c4param)
  use read_input_file; use stringlengths
  use types;use assign_objects;use alloc_objects
  use shell
  implicit none
  type(system_type),       intent(in)::syst
  type(potc4_type),        intent(in)::c4param
  double precision, intent(in)::x(syst%Npart,syst%dim)
  character*2 :: atom_types(syst%Npart)
  character(LEN=LSTR) :: src, wrk, basdir
  double precision::EpotC4
  logical :: filecheck
  integer :: i, N
  
  INQUIRE(file='CFOUR.OUT', EXIST=filecheck)
  if (.not. filecheck) then
    call execC4(x,syst)
  end if
 
  call read_inputparameter(EpotC4, "CFOUR.OUT","E(SCF)=")
  
  call do_shell('rm CFOUR.OUT')
 
  end function EpotC4
  !EF------------------------------------------

end module forcefieldc4
!EM---------------------------------------

